'use strict';

const chokidar = require('chokidar');
const path = require('node:path');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e.default : e; }

const path__default = /*#__PURE__*/_interopDefaultCompat(path);

function vitePluginYalcWatch(options) {
  return {
    name: "vite-plugin-yalc-watch",
    async configureServer(server) {
      if (options && options.length) {
        const yalcPackages = options.map((name) => path__default.resolve(process.cwd(), "node_modules", name, "package.json"));
        chokidar.watch(yalcPackages, { ignoreInitial: true }).on("all", async (event) => {
          if (event === "change" || event === "add") {
            await server.restart(true);
          }
        }).on("error", (error) => console.log(`[vite-plugin-yalc-watch]: Watcher error: ${error}`));
      }
    }
  };
}

module.exports = vitePluginYalcWatch;
